//+------------------------------------------------------------------+
//|                                            Coppock curve CCT.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_separate_window
#property indicator_buffers  3
#property indicator_color1   Green
#property indicator_color2   Red
#property indicator_color3   DarkGray
#property indicator_width3   2

//
//
//
//
//

extern int     ROCPeriod1     = 14;
extern int     ROCPeriod2     = 11;
extern int     Signal         =  5;
extern string  timeFrame      = "Current time frame";

//
//
//
//
//

double   osma[];
double   Buffer[];
double   HistBufferU[];
double   HistBufferD[];
double   SignalBuffer[];
datetime TimeArray[];
int      TimeFrame;
int      CopyLabel;
string   ShortName;
string   IndicatorFileName;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,HistBufferU); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,HistBufferD); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,osma);
   SetIndexBuffer(3,Buffer);
   SetIndexBuffer(4,SignalBuffer);

   //
   //
   //
   //
   //
   

   //
   //
   //
   //
   //

   TimeFrame = stringToTimeFrame(timeFrame);
   ShortName = "Coppock curve CCT "+TimeFrameToString(TimeFrame)+" ("+ROCPeriod1+","+ROCPeriod2+","+Signal+")";
   IndicatorShortName(ShortName);
   IndicatorFileName = WindowExpertName();

   //
   //
   //
   //
   //

   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int    counted_bars=IndicatorCounted();
   int    limit,i,k;
   double sum;


   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;


   //
   //
   //
   //
   //
   
   if (TimeFrame != Period())
      {
         limit = MathMax(limit,3*TimeFrame/Period());
         for (i=limit; i>=0; i--)
         {
            int y = iBarShift(NULL,timeFrame,Time[i]);
            HistBufferU[i]  = iCustom(NULL,TimeFrame,IndicatorFileName,ROCPeriod1,ROCPeriod2,Signal,0,y);
            HistBufferD[i]  = iCustom(NULL,TimeFrame,IndicatorFileName,ROCPeriod1,ROCPeriod2,Signal,1,y);
            osma[i]         = iCustom(NULL,TimeFrame,IndicatorFileName,ROCPeriod1,ROCPeriod2,Signal,2,y);
         }
         return(0);         
      }
         
   //
   //
   //
   //
   //

   for (i=limit;i>=0;i--)
      {
         for (sum=0.00,k=0;k<10;k++) sum += iROC(ROCPeriod1,i+k)*(10-k)+iROC(ROCPeriod2,i+k)*(10-k);

            //
            //
            //
            //
            //
                    
            Buffer[i] = sum/2;
      }
   for (i=limit;i>=0;i--)
   {
      SignalBuffer[i] = iMAOnArray(Buffer,0,Signal,0,MODE_SMA,i);
      osma[i]         = Buffer[i]-SignalBuffer[i];
      HistBufferU[i] = HistBufferU[i+1];
      HistBufferD[i] = HistBufferD[i+1];
         if (osma[i] > osma[i+1]) { HistBufferU[i] = osma[i];  HistBufferD[i] = EMPTY_VALUE; }
         if (osma[i] < osma[i+1]) { HistBufferD[i] = osma[i];  HistBufferU[i] = EMPTY_VALUE; }
   }         
      
   
   //
   //
   //
   //
   //
   
   return(0);
}
 

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

double iROC(int period, int shift)
{
   double ROC;

   if (Close[shift + period] != 0)
          ROC = (Close[shift]-Close[shift + period]) / Close[shift + period];
   else   ROC = 0.00;
   return(ROC*100.00);
}

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringTrimLeft(StringTrimRight(StringUpperCase(tfs)));
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}
string TimeFrameToString(int tf)
{
   string tfs="";
   
   if (tf!=Period())
      switch(tf) {
         case PERIOD_M1:  tfs="M1"  ; break;
         case PERIOD_M5:  tfs="M5"  ; break;
         case PERIOD_M15: tfs="M15" ; break;
         case PERIOD_M30: tfs="M30" ; break;
         case PERIOD_H1:  tfs="H1"  ; break;
         case PERIOD_H4:  tfs="H4"  ; break;
         case PERIOD_D1:  tfs="D1"  ; break;
         case PERIOD_W1:  tfs="W1"  ; break;
         case PERIOD_MN1: tfs="MN1";
      }
   return(tfs);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
         else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
         lenght--;
   }
   
   //
   //
   //
   //
   //
   
   return(s);
}